
#L10/4th Prac: Part A Simulation and Statistical Programming

#recursion
factorial<-function(x) {
	if (x==1) return(1)
	if (x>1) return(x*factorial(x-1))
	stop('x must be a positive integer')
}
factorial(5)

#what's going on inside the function
factorial<-function(x) {
	cat(rep(' ',x))
	if (x==1) {
		cat(sprintf('factorial called with x=%g\n',x))
		cat(sprintf('and returned 1\n'))
		return(1)
	}
	if (x>1) {
		cat(sprintf('factorial called with x=%g calls factorial(%g)\n',x,x-1))
		r=x*factorial(x-1)
		cat(rep(' ',x))
		cat(sprintf('factorial called with x=%g returns %g\n',x,r))
		return(r)
	}
	stop('x must be a positive integer')
}
factorial(5)

#####################################################
#Cholesky example for recursion
#
my.chol<-function(A) {
  n=dim(A)[1] #assume nxn
  if (n==1) return(sqrt(A))

  L=matrix(0,n,n)
  L[1,1]=sqrt(A[1,1])
  L[2:n,1]=A[2:n,1]/L[1,1]
  L[1,2:n]=rep(0,n-1)

  A22=A[2:n,2:n,drop=FALSE]
  L[2:n,2:n]=my.chol(A22-L[2:n,1]%*%t(L[2:n,1]))
  
  return(L)
}

#Example dimension d=2, mu=(-1,1), covariance matrix s
#s=| 5 -3|
#  |-3  4|
mu<-c(-1,1)
s<-matrix(c(5,-3,-3,4),2,2)
L<-my.chol(s)
(X<-L%*%rnorm(2)+mu)

n<-10000
X<-L%*%matrix(rnorm(2*n),2,n)+mu

apply(X,1,mean)
var(t(X))

plot(t(X))

######################################
#runtime simple example
#
my.min<-function(x) {
   a=x[1]
   for (k in 2:length(x)) {
      if (x[k]<a) a<-x[k]
   }
   a
}

###########################################
#sorting example
my.merge<-function(y,z) {
  result = c()
  while(length(y)>0 && length(z)>0) {
    if(y[1] < z[1]) {
      result = c(result, y[1])
      y = y[-1]
    } else {
      result = c(result, z[1])
      z = z[-1]
    }
  }
  #exactly one of y and z is empty
  c(result,y,z)
}

mergesort = function(x) {
  n = length(x)
  if(n < 2) { # check that vector doesnt need sorting
    result = x
  } else {
    # split vector into 2 halves
    y = x[1:(n%/%2)]
    z = x[(n%/%2 + 1):n]
    # sort two halves by calling function on each half
    y = mergesort(y)
    z = mergesort(z)
    result = my.merge(y,z)
  }
  return(result)
}

(x<-sample(-5:5,10,replace=T))
mergesort(x)

#m<-10; T<-numeric(m); n<-1024*2^(1:m); 
#r<-runif(n[m])
#for (k in 1:m) {
#	T[k]<-system.time(mergesort(r[1:n[k]]))[1]
#}
#plot(n,T); lines(n,2e-8*n^2); lines(n,3e-5*n*log(n))

