
#L12/5th Prac: Part A Simulation and Statistical Programming

A=matrix(c(1,2,3,4),2,2); A
B=cbind(1:3,4:6); B
dim(B)

#subsetting kills the dim attribute
A[,1]
dim(A[,1])
A[,1,drop=F]
dim(A[,1,drop=F])

#solving equations
b=matrix(c(1,2),2,1); b
solve(A,b)
solve(A)%*%b
#solve is about (2/3)n^3 (+LOT)

#inversion
solve(A)
solve(A)%*%A
solve(A)%*%b
#this is about (8/3)n^3 = (2/3)n^3+n*2n^2 (+LOT)

n<-1500; A<-matrix(runif(n^2),n,n); b<-matrix(runif(n),n,1)
system.time(x<-solve(A,b))
system.time({Ai<-solve(A); y<-Ai%*%b})

##
#forward substitution for LOWER triangular A
#solve Ax=b for x

# |1 0 0| |x[1]|   |3|
# |2 5 0| |x[2]| = |2|
# |3 6 9| |x[3]|   |1|

#build lower triangular A for example 
A=matrix(1:9,3,3); 
A
A[upper.tri(A)]<-0; 
A 
upper.tri(A)
b=matrix(c(3,2,1),3,1); b

#R has builtin fn forwardsolve(A,b) (about n^2 flops)
x.soln<-forwardsolve(A,b); x.soln
A%*%x.soln #equals b

#our implementation of forward elimination
my.forwards<-function(A,b) {
	n=dim(A)[1] #assume nxn
	if (n==1) return(b/A) 

	x=matrix(0,n,1)
	x[1]=b[1]/A[1,1]
	b2=b[2:n]-A[2:n,1]*x[1]
	A22=A[2:n,2:n,drop=FALSE]

	x[2:n]=my.forwards(A22,b2)

	return(x)
}

x=my.forwards(A,b); x
A%*%x

## 
#Normal Linear Models
d = read.table("http://www.stats.ox.ac.uk/~nicholls/PartASSP/data/AIDS.txt")
head(d)
(n<-dim(d)[1])
plot(d$time,d$cases,xlab='time [months]',ylab='cases',cex.lab=1.5)

#The R routines fitting normal linear models
d.lm=lm(cases~time+time.sq,data=d)
summary(d.lm)
#GOF
lines(d$time,fitted(d.lm))
#windows(); plot(fitted(d.lm),residuals(d.lm))
qqnorm(residuals(d.lm)); qqline(residuals(d.lm))

#QR
X=matrix(c(1, 0, 0, -1, 1e-10, 0),3,2); X
y=matrix(c(0, 1e-10, 1),3,1); y
1+(1e-20)==1
#easy to show soln is x=c(1,1)
theta=c(1,1)
t(X)%*%(X%*%theta)
t(X)%*%y

solve(t(X)%*%X,t(X)%*%y)
t(X)%*%X

theta=qr.solve(X,y,tol=0); theta

#compute theta-hat (d.theta) ourselves 
X<-cbind(rep(1,n),d$time,d$time.sq)
(d.theta<-qr.solve(X,d$cases))

qrf=qr(X)
Q=qr.Q(qrf); Q
R=qr.R(qrf); R
Q%*%R
theta=backsolve(R,t(Q)%*%d$cases); theta
R%*%theta; t(Q)%*%d$cases

#Remark: I havnt discussed pivoting. If pivoting
#is needed the R and Q returned by R wont work in the
#simle way I have presented it above - but qr.solve etc 
#work as usual